from sqlite3 import Connection as SQLite3Connection
from datetime import datetime
from sqlalchemy import event
from sqlalchemy.engine import Engine
from flask import Flask, request, jsonify
from flask_sqlalchemy import SQLAlchemy
import linked_list

# app
app = Flask(__name__)

app.config["SQLALCHEMY_DATABASE_URI"] = "sqlite:///sqlitedb.file"
app.config["SQLALCHEMY_TRACK_MODIFICATIONS"] = 0

# configure sqlite3 to enforce foreign key contraints
@event.listens_for(Engine, "connect")
def _set_sqlite_pragma(dbapi_connection, connection_record):
    if isinstance(dbapi_connection, SQLite3Connection):
        cursor = dbapi_connection.cursor()
        cursor.execute("PRAGMA foreign_keys=ON;")
        cursor.close()


db = SQLAlchemy(app)
now = datetime.now()

# models
class User(db.Model):
    __tablename__ = "user"
    id = db.Column(db.Integer, primary_key=True)
    name = db.Column(db.String(50))
    email = db.Column(db.String(50))
    address = db.Column(db.String(200))
    phone = db.Column(db.String(50))
    posts = db.relationship("BlogPost", cascade="all, delete")


class BlogPost(db.Model):
    __tablename__ = "blog_post"
    id = db.Column(db.Integer, primary_key=True)
    title = db.Column(db.String(50))
    body = db.Column(db.String(200))
    date = db.Column(db.Date)
    user_id = db.Column(db.Integer, db.ForeignKey("user.id"), nullable=False)


# routes are method to be used by postman
@app.route("/user", methods=["POST"])
def create_user():
    # Question 1.1: create a request using json
    
    # Question 1.2: create a user
    
    # Question 1.3: add the user to the database
    
    # Question 1.4: commit to the database
    
    # Question 1.5: send the right message
    return 


# routes are method to be used by postman
# Question 2.1 : 
# get the list of all the users in descending order
# use a linked list
@app.route("/user/descending_id", methods=["GET"])
def get_all_users_descending():
    # routes are method to be used by postman

# Question 3.1 : 
# get the list of all the users in descending order
# use a linked list
@app.route("/user/ascending_id", methods=["GET"])
def get_all_users_ascending():




if __name__ == "__main__":
    app.run(debug=True)
